/***************************************************************************
 *   Copyright 2005 Benjamin Meyer <ben@meyerhome.net>                      *
 *   Copyright 2006 Alexander Dymo <adymo@kdevelop.org>                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.         *
 ***************************************************************************/
#ifndef DRILLDOWNVIEW_H
#define DRILLDOWNVIEW_H

#include <QtGui/QtGui>

class DrillDownView: public QListView {
     Q_OBJECT
public:
    DrillDownView(QWidget *parent = 0);
//     QModelIndex moveCursor(CursorAction cursorAction, Qt::KeyboardModifiers modifiers);

    void slideLeft();
    void slideRight();

    void setDirty(const QRect& rect);

    bool isBusy();

public Q_SLOTS:
//     void currentChanged( const QModelIndex &current, const QModelIndex &previous );
    void slide(int x);
    void setRootIndex(const QModelIndex &index);
    void animateNewUrl();

protected Q_SLOTS:
    virtual void verticalScrollbarValueChanged(int value);
    virtual void horizontalScrollbarValueChanged(int value);

Q_SIGNALS:
    void tryToSlideLeft();
    void returnPressed(const QModelIndex &index);
    void rootIndexChanged(const QModelIndex &index);

protected:
    virtual void paintEvent(QPaintEvent * event);
    virtual void keyPressEvent(QKeyEvent *event);
    virtual void scrollContentsBy(int dx, int dy);
//    virtual void mousePressEvent(QMouseEvent* event);

private:
    void animateSlide(int moveDirection);
    QRect normalizeDrillIconRect(const QRect &rect);

    QTimeLine animation;
    QPixmap oldView;
    QPixmap newView;
    int lastPosition;

    bool needSlideLeftAnimation;
    QModelIndex newUrlIndex;

    friend class DrillDownItemDelegate;
};

#endif
